$(function(){
	//页面初始化加载教育经历
	if (typeof education_experience_list != 'undefined')
	{
		$.each(education_experience_list,function(i, e){
			$('.aw-user-educate table tbody').append('<tr data-id="'+e.education_id+'">'+Hogan.compile(AW_TEMPLATE.educateInsert).render({
				'school' : e.school_name,
				'departments' : e.departments,
				'year' : e.education_years
			})+'</tr>');
		});
	}
	
	//页面初始化加载工作经历
	if (typeof work_experience_list != 'undefined')
	{
		$.each(work_experience_list,function(i, e){
			$('.aw-user-work table tbody').append('<tr data-id="'+e.work_id+'">'+Hogan.compile(AW_TEMPLATE.workInsert).render({
				'company' : e.company_name,
				'jobid' : e.job_id,
				'work' : e.job_name,
				'syear' : e.start_year,
				'eyear' : e.end_year
			})+'</tr>');
		});
	}

	//教育经历添加,编辑
	$(document).on('click','.add-educate',function()
	{
		AWS.loading('show');

		var _this = $(this),
			school = $(this).parents('tr').find('.school').val(),
			departments = $(this).parents('tr').find('.departments').val(),
			year = $(this).parents('tr').find('.year').val(),
			eduid = $(this).parents('tr').attr('data-id');
		if (eduid == undefined)
		{
			var url = G_BASE_URL + '/account/ajax/add_edu/';
		}
		else
		{
			var url = G_BASE_URL + '/account/ajax/edit_edu/' + eduid;
		}

		$.post(url, {'school_name':school,'education_years':year,'departments':departments}, function (result)
		{
			AWS.loading('hide');

			if (result.errno != 1)
			{
				AWS.alert(result.err);
			}
			else
			{
				if (eduid == undefined)
				{
					_this.parents('tbody').append('<tr class="collapse" data-id="'+ result.rsm.id +'">'+Hogan.compile(AW_TEMPLATE.educateInsert).render({
						'school' : school,
						'departments' : departments,
						'year' : year
					})+'</tr>');
					_this.parents('tbody').find('tr.collapse').fadeIn();
					_this.parents('tr').find('.school,.departments,.year').val('');
				}
				else
				{
					_this.parents('tr').html(Hogan.compile(AW_TEMPLATE.educateInsert).render({
						'school' : school,
						'departments' : departments,
						'year' : year
					}));
				}
			}
		},'json');
	});
	//教育经历删除
	$(document).on('click','.delete-educate',function()
	{
		AWS.loading('show');
		var _this = $(this),
			eduid = _this.parents('tr').attr('data-id');
		
		$.post(G_BASE_URL+"/account/ajax/remove_edu/" + eduid,{'id':eduid}, function (result)
		{
			AWS.loading('hide');
			_this.parents('tr').fadeOut('slow',function(){
				_this.parents('tr').detach();
			});
		});
	});
	//教育经历编辑
	$(document).on('click','.edit-educate',function()
	{
		var syear = $(this).parents('tr').find('.e3').attr('data-txt');
		$(this).parents('tr').html(Hogan.compile(AW_TEMPLATE.educateEdit).render({
				'school' : $(this).parents('tr').find('.e1').attr('data-txt'),
				'departments' : $(this).parents('tr').find('.e2').attr('data-txt')
			}));
		$('.edityear').append($('.aw-user-educate .year option').clone()).val(syear);
	});
	
	//工作经历添加,编辑
	$(document).on('click','.add-work',function()
	{
		AWS.loading('show');

		var _this = $(this),
			company = $(this).parents('tr').find('.company').val(),
			workid = $(this).parents('tr').find('.work').val(),
			syear = $(this).parents('tr').find('.syear').val(),
			eyear = $(this).parents('tr').find('.eyear').val(),
			work = $(this).parents('tr').find('.work option[value="'+workid+'"]').text(),
			workEditId  = $(this).parents('tr').attr('data-id');
		if (workEditId == undefined)
		{
			var url = G_BASE_URL + '/account/ajax/add_work/';
		}
		else
		{
			var url = G_BASE_URL + '/account/ajax/edit_work/' + workEditId;
		}

		$.post(url, {'company_name':company,'job_id':workid,'start_year':syear,'end_year':eyear}, function (result)
		{
			AWS.loading('hide');

			if (result.errno != 1)
			{
				AWS.alert(result.err);
			}
			else
			{
				if (workEditId == undefined)
				{
					_this.parents('tbody').append('<tr class="collapse" data-id="'+result.rsm.id+'">'+Hogan.compile(AW_TEMPLATE.workInsert).render({
						'company' : company,
						'work' : work,
						'syear' : syear,
						'eyear' : eyear,
						'jobid' : workid
					})+'</tr>');
					_this.parents('tbody').find('tr.collapse').fadeIn();
					_this.parents('tr').find('.company,.work,.syear,.eyear').val('');
				}
				else
				{
					_this.parents('tr').html(Hogan.compile(AW_TEMPLATE.workInsert).render({
						'company' : company,
						'work' : work,
						'jobid' : workid,
						'syear' : syear,
						'eyear' : eyear
					}));
				}
			}
		},'json');
	});

	//工作经历编辑
	$(document).on('click','.edit-work',function()
	{
		var work = $(this).parents('tr').find('.w2').attr('data-txt'),
			syear = $(this).parents('tr').find('.w3').attr('data-s-val'),
			eyear = $(this).parents('tr').find('.w3').attr('data-e-val');
		$(this).parents('tr').html(Hogan.compile(AW_TEMPLATE.workEidt).render({
				'company' : $(this).parents('tr').find('.w1').attr('data-txt')
			}));
		$('.editwork').append($('.aw-user-work .work option').clone()).val(work);
		$('.editsyear').append($('.aw-user-work .syear option').clone()).val(syear);
		$('.editeyear').append($('.aw-user-work .eyear option').clone()).val(eyear);
	});
	//工作经历删除
	$(document).on('click','.delete-work',function()
	{
		AWS.loading('show');

		var _this = $(this),
			workid = $(this).parents('tr').attr('data-id');
		
		$.post(G_BASE_URL+"/account/ajax/remove_work/" + workid,{'id':$(this).parents('tr').attr('data-id')}, function (result)
		{
			AWS.loading('hide');

			_this.parents('tr').fadeOut('slow',function(){
				_this.parents('tr').detach();
			});
		});
	});

});